C     PROGRAM TO READ AND DISPLAY PARAMETERS STORED IN FILE PPP.RES FROM
C     PAWLEY-PROGRAM GENERATED IN CYCLIC REFINEMENT
C     (JUNE 1987). JUAN RODRIGUEZ
C 
C      MX= MAXIMUM NUMBER OF PATTERNS STORED IN FILE PPP.RES
C      NL= MINIMUN NUMBER OF PEAKS
C      
C      CURRENT DIMENSIONS:   MX=500
C                            NL=100
C
C      THE MAIN PROGRAM READ PARAMETERS FROM FILE PPP.RES AND STORE THEM
C      IN ARRAYS, PERFORMS THE CALCULATION OF STANDARD DEVIATION OF
C      VOLUME CELL AND TRANSFORM THE CELL (IS NEEDED) SAVING IT IN A FILE
C      TO BE PROCESSED BY PLTCELL PROGRAM.
C
C      THE PROGRAM IS NOT OPTIMIZED FOR A SAKE OF CLARITY. REPETITIVE
C      SENTENCES CAN BE GROUPED IN SUBROUTINES, BUT YOU MUST DEFINE 
C      NEW VARIABLES WICH NEED BE ACTUALIZED FOR EACH KIND OF PARAMETER
C      BEFORE CALLING THE SUBROUTINES.
C
C-------------------------------------------------------------------------
	PARAMETER (MX=500,NL=100)
        IMPLICIT REAL*8 (A-H,O-Z)
        CHARACTER TITLE*40
	CHARACTER*16 FILEN1,FILEN3
	CHARACTER*1 WHAT,WFI
C
	DIMENSION ZERO(MX),U(MX),V(MX),W(MX),ALO(MX),A(MX),B(MX),C(MX)
	DIMENSION ALFA(MX),BETA(MX),GAMMA(MX),AN(6),SAN(6)
	DIMENSION SZERO(MX),SU(MX),SV(MX),SW(MX),SALO(MX),SA(MX),SB(MX)
	DIMENSION SC(MX),SALFA(MX),SBETA(MX),SGAMMA(MX),TM(3,3)
	DIMENSION T(MX),IHKL(NL,4),RPIK(MX),AREA(MX,NL),THETA(MX,NL)
	DIMENSION SAREA(MX,NL),VOL(MX),SVOL(MX),NUMOR(MX),RZER(MX)
C 
        COMMON/TEMP/N,TITLE,NUMOR,T,RPIK,RZER
        COMMON/PROFALL/ZERO,SZERO,U,SU,V,SV,W,SW,ALO,SALO,A,SA,B,SB,C,SC
     &,ALFA,SALFA,BETA,SBETA,GAMMA,SGAMMA,VOL,SVOL
        COMMON/INTEN/NREF,IHKL,THETA,AREA,SAREA
        COMMON/LIMIN/Z1,U1,V1,W1,ALO1,A1,B1,C1,AL1,BE1,CE1,VOL1,T1,NUM1
        COMMON/LIMAX/Z2,U2,V2,W2,ALO2,A2,B2,C2,AL2,BE2,CE2,VOL2,T2,NUM2
	COMMON/TRANF/ AN,SAN
        COMMON/IFIT/ICOD(15),IROMB,ISYST,RP1,RP2
C
	DATA RAD/57.2957795131/,IOI/3/,ISAV/7/
C
	SIN120=DSIN(120.0D0/RAD)
	SQT2=DSQRT(2.0D0)
	SQT3=DSQRT(3.0D0)
        DO I=1,15
         ICOD(I)=0
        END DO
        IROMB=0
C
C     OPEN INPUT AND OUTPUT FILES
C
	TYPE*,' ******   PROGRAM DISPAW   ******* '
C
        TYPE*,'      '
	TYPE*,'  PROGRAM TO DISPLAY PARAMETERS FITTED BY CYCLIC-PAWLEY '
	TYPE*,'  '
 2021	TYPE*,'NAME OF THE INPUT FILE  (E.G. PPPOUT.RES)'
  200   FORMAT(A16)
	ACCEPT 200,FILEN1
	OPEN(UNIT=IOI,NAME=FILEN1,TYPE='OLD',READONLY,ERR=2019)
        GOTO 2020
 2019   TYPE 200,'FILE:',FILEN1,'NOT EXISTENT'
        GOTO 2021
C
C   SET INITIAL LIMITS FOR PROFILE PARAMETERS, TEMPERATURE AND NUMORS
C
 2020	T2=-500000.0
	T1=5000000.0
        Z2=-1000.0
        Z1=1000.0
	U2=-1000.0
	U1=1000.0
	V2=-1000.0
	V1=1000.0
	W2=-1000.0
	W1=1000.0
	ALO2=-1000.0
	ALO1=1000.0
	A2=-1000.0
	A1=1000.0
	A2H=-1000.0
	A1H=1000.0
	B2=-1000.0
	B1=1000.0
	C2=-1000.0
	C1=1000.0
	C2H=-1000.0
	C1H=1000.0
	AL2=-1000.0
	AL1=1000.0
	BE2=-1000.0
	BE1=1000.0
	CE2=-1000.0
	CE1=1000.0
	VOL2=-100000.0
	VOL1=100000.0
        NUM2=-100000
        NUM1=9999999
        RP1=100000.0
        RP2=-100000.0
C
C      READ THE INPUT FILE AND DO THE VOLUME CELL CALCULATIONS
C
        N=1
 1000	READ(IOI,500,END=2000)NUMOR(N),NSUM,T(N)
  500	FORMAT(I6,1X,I4,1X,F12.0)
  	IF(T(N).GT.T2)T2=T(N)
	IF(T(N).LT.T1)T1=T(N)
	IF(NUMOR(N).GT.NUM2)NUM2=NUMOR(N)
	IF(NUMOR(N).LT.NUM1)NUM1=NUMOR(N)
	READ(IOI,501) TITLE
  501	FORMAT(A40)
        READ(IOI,271) NP,NREF,ISYST
        IF(N.GT.1) GOTO 354
        IF(ISYST.NE.5) GOTO 354
        TYPE*,'RHOMBOHEDRAL OR HEXAGONAL CELL (R/H)'
        ACCEPT 355,WFI
  355   FORMAT(A)
        IF(WFI.EQ.'R'.OR.WFI.EQ.'r') IROMB=1
  271   FORMAT(3I5)
  502	FORMAT(I5,2F12.5)
  354	DO 16 I=1,11
	READ(IOI,502)ICO,P,SP
	GOTO(5,5,5,5,5,6,7,8,9,10,11,12,13,14,15),ICO
    5	  ZERO(N)=P
	  SZERO(N)=SP
	IF(P+SP.GT.Z2)Z2=P+SP
	IF(P-SP.LT.Z1)Z1=P-SP
          IF(SP.NE.0) ICOD(5)=1
          IF(SP.EQ.0.AND.ICOD(5).EQ.1) SZERO(N)=SZERO(N-1)
	  GOTO 16
    6	  U(N)=P
	  SU(N)=SP
	IF(P+SP.GT.U2)U2=P+SP
	IF(P-SP.LT.U1)U1=P-SP
          IF(SP.NE.0) ICOD(6)=1
          IF(SP.EQ.0.AND.ICOD(6).EQ.1) SU(N)=SU(N-1)
	  GOTO 16
    7	  V(N)=P
	  SV(N)=SP
	IF(P+SP.GT.V2)V2=P+SP
	IF(P-SP.LT.V1)V1=P-SP
          IF(SP.NE.0)ICOD(7)=1
          IF(SP.EQ.0.AND.ICOD(7).EQ.1) SV(N)=SV(N-1)
	  GOTO 16
    8	  W(N)=P
	  SW(N)=SP
	IF(P+SP.GT.W2)W2=P+SP
	IF(P-SP.LT.W1)W1=P-SP
          IF(SP.NE.0) ICOD(8)=1
          IF(SP.EQ.0.AND.ICOD(8).EQ.1) SW(N)=SW(N-1)
	  GOTO 16
    9	  ALO(N)=P
	  SALO(N)=SP
	IF(P+SP.GT.ALO2)ALO2=P+SP
	IF(P-SP.LT.ALO1)ALO1=P-SP
          IF(SP.NE.0) ICOD(9)=1
          IF(SP.EQ.0.AND.ICOD(9).EQ.1) SALO(N)=SALO(N-1)
	  GOTO 16
   10	  A(N)=P
	  SA(N)=SP
          IF(SP.NE.0) ICOD(10)=1
          IF(SP.EQ.0.AND.ICOD(10).EQ.1) SA(N)=SA(N-1)
	IF(P+SP.GT.A2)A2=P+SP
	IF(P-SP.LT.A1)A1=P-SP
	IF(ISYST.EQ.5) THEN
          A1R=A1
          A2R=A2
        ENDIF
	  GOTO 16
   11	  B(N)=P
	  SB(N)=SP
          IF(SP.NE.0) ICOD(11)=1
          IF(SP.EQ.0.AND.ICOD(11).EQ.1) SB(N)=SB(N-1)
	IF(P+SP.GT.B2)B2=P+SP
	IF(P-SP.LT.B1)B1=P-SP
	  GOTO 16
   12	  C(N)=P
	  SC(N)=SP
          IF(SP.NE.0) ICOD(12)=1
          IF(SP.EQ.0.AND.ICOD(12).EQ.1) SC(N)=SC(N-1)
	IF(P+SP.GT.C2)C2=P+SP
	IF(P-SP.LT.C1)C1=P-SP
	  GOTO 16
   13	  ALFA(N)=P
	  SALFA(N)=SP
          IF(SP.NE.0) ICOD(13)=1
          IF(SP.EQ.0.AND.ICOD(13).EQ.1) SALFA(N)=SALFA(N-1)
	IF(P+SP.GT.AL2)AL2=ALFA(N)+SP
	IF(P-SP.LT.AL1)AL1=ALFA(N)-SP
          IF(ISYST.EQ.5) THEN
          AL1R=AL1
          AL2R=AL2
        ENDIF      
	  GOTO 16
   14	  BETA(N)=P
	  SBETA(N)=SP
          IF(SP.NE.0) ICOD(14)=1
          IF(SP.EQ.0.AND.ICOD(14).EQ.1) SBETA(N)=SBETA(N-1)
	IF(P+SP.GT.BE2)BE2=BETA(N)+SP
	IF(P-SP.LT.BE1)BE1=BETA(N)-SP
	  GOTO 16
   15	  GAMMA(N)=P
	  SGAMMA(N)=SP
          IF(SP.NE.0) ICOD(15)=1
          IF(SP.EQ.0.AND.ICOD(15).EQ.1) SGAMMA(N)=SGAMMA(N-1)
	IF(P+SP.GT.CE2)CE2=GAMMA(N)+SP
	IF(P-SP.LT.CE1)CE1=GAMMA(N)-SP
   16	CONTINUE
	GOTO(401,402,403,404,405,406,407),ISYST
  401	B(N)=A(N)
	C(N)=A(N)
	ALFA(N)=90.0
	BETA(N)=90.0
	GAMMA(N)=90.0
	VOL(N)=A(N)*A(N)*A(N)
	SVOL(N)=3.0*VOL(N)*SA(N)/A(N)
	IF(VOL(N)+SVOL(N).GT.VOL2)VOL2=VOL(N)+SVOL(N)
	IF(VOL(N)-SVOL(N).LT.VOL1)VOL1=VOL(N)-SVOL(N)
	GOTO 408
  402	B(N)=A(N)
	ALFA(N)=90.0
	BETA(N)=90.0
	GAMMA(N)=90.0
	VOL(N)=A(N)*A(N)*C(N)
	SVOL(N)=DSQRT((2.0*A(N)*C(N)*SA(N))**2+(A(N)*SC(N))**2)
	IF(VOL(N)+SVOL(N).GT.VOL2)VOL2=VOL(N)+SVOL(N)
	IF(VOL(N)-SVOL(N).LT.VOL1)VOL1=VOL(N)-SVOL(N)
	GOTO 408
  403	ALFA(N)=90.0
	BETA(N)=90.0
	GAMMA(N)=90.0
	VOL(N)=A(N)*B(N)*C(N)
	SVOL(N)=DSQRT((SA(N)/A(N))**2+(SB(N)/B(N))**2+(SC(N)/C(N))**2)
	SVOL(N)=SVOL(N)*VOL(N)
	IF(VOL(N)+SVOL(N).GT.VOL2)VOL2=VOL(N)+SVOL(N)
	IF(VOL(N)-SVOL(N).LT.VOL1)VOL1=VOL(N)-SVOL(N)
	GOTO 408
  404	B(N)=A(N)
	ALFA(N)=90.0
	BETA(N)=90.0
	GAMMA(N)=120.0
	VOL(N)=A(N)*A(N)*C(N)*SIN120
	SVOL(N)=DSQRT(2.0*(SA(N)/A(N))**2+(SC(N)/C(N))**2)
	SVOL(N)=SVOL(N)*VOL(N)
	IF(VOL(N)+SVOL(N).GT.VOL2)VOL2=VOL(N)+SVOL(N)
	IF(VOL(N)-SVOL(N).LT.VOL1)VOL1=VOL(N)-SVOL(N)
        IF(IROMB.EQ.0) GOTO 408
        A(N)=AR
        B(N)=AR
        C(N)=AR
        SA(N)=SAR
        ALFA(N)=ALFR
        BETA(N)=ALFR
        GAMMA(N)=ALFR
        SALFA(N)=SAL*RAD
        VOL(N)=VOL(N)/3.0
        SVOL(N)=SVOL(N)/3.0
	GOTO 408
  405	AR=A(N)
	SAR=SA(N)
	SAL=SALFA(N)/RAD
        SL=SAL*SAL
        ALFR=ALFA(N)
	AC=DCOS(ALFA(N)/RAD)
	AS=DSIN(ALFA(N)/RAD)
	AC1=1.0-AC
	AC2=1.0+2.0*AC
	A(N)=AR*SQT2*DSQRT(AC1)
	C(N)=AR*SQT3*DSQRT(AC2)
	SA(N)=DSQRT(2.0*AC1*SAR*SAR+0.5*(AR*AS)**2/AC1*SL)
	SC(N)=DSQRT(3.0*AC2*SAR*SAR+3.0*(AR*AS)**2/AC2*SL)
	IF(A(N)+SA(N).GT.A2H)A2H=A(N)+SA(N)
	IF(A(N)+SA(N).LT.A1H)A1H=A(N)-SA(N)
	IF(C(N)+SC(N).GT.C2H)C2H=C(N)+SC(N)
	IF(C(N)-SC(N).LT.C1H)C1H=C(N)-SC(N)
	GOTO 404
  406	ALFA(N)=90.0
	GAMMA(N)=90.0
	AC=DCOS(BETA(N)/RAD)
	AS=DSIN(BETA(N)/RAD)
	A3=A(N)*B(N)*C(N)
	VOL(N)=A3*AS
	V1=(SA(N)/A(N))**2+(SB(N)/B(N))**2+(SC(N)/C(N))**2
	V1=V1+(AC/AS*SBETA(N)/RAD)**2
	SVOL(N)=VOL(N)*DSQRT(V1)
	IF(VOL(N)+SVOL(N).GT.VOL2)VOL2=VOL(N)+SVOL(N)
	IF(VOL(N)-SVOL(N).LT.VOL1)VOL1=VOL(N)-SVOL(N)
	GOTO 408
  407	AC=DCOS(ALFA(N)/RAD)
	AS=DSIN(ALFA(N)/RAD)
  	BC=DCOS(BETA(N)/RAD)
	BS=DSIN(BETA(N)/RAD)
  	CC=DCOS(GAMMA(N)/RAD)
	CS=DSIN(GAMMA(N)/RAD)
	AR=DSQRT(1.0-AC*AC-BC*BC-CC*CC+2.0*AC*BC*CC)
	A3=A(N)*B(N)*C(N)
	AD=(AC-BC*CC)*AS
	BD=(BC-AC*CC)*BS
	CD=(CC-AC*BC)*CS
	VOL(N)=A3*AR
	V1=(SA(N)/A(N))**2+(SB(N)/B(N))**2+(SC(N)/C(N))**2
	V1=VOL(N)*VOL(N)*V1
	VA=(AD*SALFA(N)/RAD)**2+(BD*SBETA(N)/RAD)**2
	VA=VA+(CD*SGAMMA(N)/RAD)**2
	VA=VA*(A3/AR)**2
	SVOL(N)=DSQRT(V1+VA)
	IF(VOL(N)+SVOL(N).GT.VOL2)VOL2=VOL(N)+SVOL(N)
	IF(VOL(N)-SVOL(N).LT.VOL1)VOL1=VOL(N)-SVOL(N)
  408	CONTINUE  
        DO L=1,NREF
       	READ(IOI,510)(IHKL(L,J),J=1,4),THETA(N,L),AREA(N,L),SAREA(N,L)
        END DO
  510	FORMAT(1X,3I4,3X,I3,F8.3,2F10.2)
	READ(IOI,201) VCELL
  201   FORMAT(F10.0)
        READ(IOI,503) RZER(N)
	READ(IOI,503) RPIK(N)
        IF(RZER(N).GT.RP2) RP2=RZER(N)
        IF(RZER(N).LT.RP1) RP1=RZER(N)
        IF(RPIK(N).GT.RP2) RP2=RPIK(N)
        IF(RPIK(N).LT.RP1) RP1=RPIK(N)
  503	FORMAT(50X,F10.3)
	N=N+1
	GOTO 1000
 2000	N=N-1
        CLOSE(UNIT=IOI)
        IF(ISYST.EQ.5) THEN
           IF(IROMB.EQ.1) THEN
            VOL1=VOL1/3.
            VOL2=VOL2/3.
            A1=A1R
            A2=A2R
            AL1=AL1R
            AL2=AL2R
           ELSE
            A1=A1H
            A2=A2H
            C1=C1H
            C2=C2H
           ENDIF
         ENDIF
         
C
C    END OF READING INPUT FILE AND ASK FOR SAVING CELL PARAMETERS
C
	TYPE*,'SAVE CELL PARAMETERS AND T IN FILE?(Y/N)'
	ACCEPT 151,WHAT
	IF(WHAT.NE.'Y') GOTO 2001
	TYPE*,'NAME OF THE OUTPUT FILE'
	ACCEPT 200,FILEN3
	OPEN(UNIT=7,NAME=FILEN3,TYPE='UNKNOWN')
	WRITE(ISAV,501)TITLE
	TYPE*,'DO YOU WANT TO TRANSFORM THE CELL? (Y/N)'
	ACCEPT 151, WHAT
	IF(WHAT.NE.'Y') GOTO 672
	TYPE*,'ENTER THE TRANSFORMATION MATRIX BY ROWS'
	DO I=1,3
 2023	TYPE*,'ROW:',I
	READ(5,*,ERR=2023) (TM(I,J),J=1,3)
	END DO
	Z=TM(1,1)*TM(2,2)*TM(3,3)+TM(2,1)*TM(1,3)*TM(3,2)
	Z=Z+TM(1,2)*TM(2,3)*TM(3,1)-TM(2,2)*TM(1,3)*TM(3,1)
	Z=Z-TM(1,1)*TM(2,3)*TM(3,2)-TM(3,3)*TM(1,2)*TM(2,1)
	Z=1./Z
	GOTO 673
  672	TYPE*,'DENOMINATOR OF THE VOLUME TO BE STORED:V=VCELL/Z'
	READ(5,*,ERR=672) Z
  673	DO 750 I=1,N
	AN(1)=A(I)
	AN(2)=B(I)
	AN(3)=C(I)
	AN(4)=ALFA(I)
	AN(5)=BETA(I)
	AN(6)=GAMMA(I)  
	VZ=VOL(I)/Z
	SAN(1)=SA(I)
	SAN(2)=SB(I)
	SAN(3)=SC(I)
	SAN(4)=SALFA(I)
	SAN(5)=SBETA(I)
	SAN(6)=SGAMMA(I)  
	SVZ=SVOL(I)/Z
	IF(WHAT.EQ.'Y') CALL TRANS(TM,ISYST,IROMB)
	WRITE(ISAV,703)T(I),(AN(L),L=1,6),VZ
	WRITE(ISAV,704)(SAN(L),L=1,6),SVZ
  750	CONTINUE
        CLOSE(UNIT=ISAV)
  703	FORMAT((1X,F8.1,3F9.4,3F8.3,F10.3))
  704	FORMAT((9X,3F9.4,3F8.3,F10.3))
  151	FORMAT(A1)
C
C    BEGINING THE PLOTS
C
 2001   TYPE*,'DO YOU WANT TO CALCULATE SOME AVERAGE VALUES(Y/N)'  
	ACCEPT 151,WHAT
	IF(WHAT.NE.'Y') GOTO 2002
        TYPE*,'YOU HAVE ',N,' VALUES OF EACH PARAMETERS'
        TYPE*,'ENTER THE FIRST AND LAST INDEX TO AVERAGE THEM'
        ACCEPT*,IND1,IND2
        NAV=IABS(IND2-IND1)+1
        RNAV=DFLOAT(NAV)
        RNAV1=RNAV-1.0D0
        INI=MIN(IND1,IND2)
        INF=INI+NAV-1
2015    TYPE*,'  '
        TYPE*,'      AVERAGE VALUES OPTIONS:'
        TYPE*,'      ********************** ' 
 	TYPE*,'  1-  ZEROPOINT '
        TYPE*,'  2-  U,V,W,ALOR'       
        TYPE*,'  3-  R-FACTORS' 
        TYPE*,'  4-  QUIT '
	TYPE*,'                     '
        READ(5,*,ERR=2015) IOP
        GOTO(2011,2012,2013,2002),IOP
        GOTO 2015
2011    SUM=0.0
        DO I=INI,INF
        SUM=SUM+ZERO(I)
        END DO
        ZAV=SUM/RNAV
        SUM=0.0
        DO I=INI,INF
        SUM=(ZAV-ZERO(I))**2+SUM
        END DO
        SZAV=DSQRT(SUM/RNAV1)
        WRITE(6,2200) ZAV,SZAV
2200    FORMAT(' AVERAGE VALUE FOR ZEROPOINT : ',F10.5/
     $  '         R.M.S. OF DEVIATIONS: ',F10.5)
        GOTO 2016
2012    SUMU=0.0
        SUMV=0.0
        SUMW=0.0
        SUMA=0.0
        DO I=INI,INF
        SUMU=SUMU+U(I)
        SUMV=SUMV+V(I)
        SUMW=SUMW+W(I)
        SUMA=SUMA+ALO(I)
        END DO
        UAV=SUMU/RNAV
        VAV=SUMV/RNAV
        WAV=SUMW/RNAV
        AAV=SUMA/RNAV
        SUMU=0.0
        SUMV=0.0
        SUMW=0.0
        SUMA=0.0
        DO I=INI,INF
        SUMU=(UAV-U(I))**2+SUMU
        SUMV=(VAV-V(I))**2+SUMV
        SUMW=(WAV-W(I))**2+SUMW
        SUMA=(AAV-ALO(I))**2+SUMA
        END DO
        SUAV=DSQRT(SUMU/RNAV1)
        SVAV=DSQRT(SUMV/RNAV1)
        SWAV=DSQRT(SUMW/RNAV1)
        SAAV=DSQRT(SUMA/RNAV1)
        TYPE*,'AVERAGE VALUE FOR U,V,W,ALO : '
        TYPE*,'AND R.M.S. OF DEVIATIONS: '
        TYPE 2201,UAV,VAV,WAV,AAV
        TYPE 2201,SUAV,SVAV,SWAV,SAAV
2201    FORMAT(4F10.5)
        GOTO 2016
2013    SUMA=0.0
        SUMP=0.0
        DO I=INI,INF
        SUMA=SUMA+RZER(I)
        SUMP=SUMP+RPIK(I)
        END DO
        RZAV=SUMA/RNAV
        RPAV=SUMP/RNAV
        SUMA=0.0
        SUMP=0.0
        DO I=INI,INF
        SUMA=(RZAV-RZER(I))**2+SUMA
        SUMP=(RPAV-RPIK(I))**2+SUMP
        END DO
        SRZAV=DSQRT(SUMA/RNAV1)
        SRPAV=DSQRT(SUMP/RNAV1)
        WRITE(6,2203)RZAV,SRZAV,RPAV,SRPAV
2203    FORMAT(' AVERAGE VALUE OF R-FACTOR (OVERALL) : ',F10.5/
     $  '                 R.M.S. OF DEVIATIONS: ',F10.5/
     $  ' AVERAGE VALUE OF R-FACTOR (PEAKS) : ',F10.5/
     $  '               R.M.S. OF DEVIATIONS: ',F10.5)
2016    WRITE(6,2202)IND1,IND2
2202    FORMAT(' VALUES CALCULATED BETWEEN INDEX: ',2I5)
        TYPE*,'PRESS <CR> TO CONTINUE'
        ACCEPT 151,WHAT
        GOTO 2015
2002   CALL DIBUJO
	STOP
	END
C
C-------------------------------------------------------------------------
	SUBROUTINE TRANS(TM,ISYST,IROMB)
        IMPLICIT REAL*8 (A-H,O-Z)
	DIMENSION G(3,3),TM(3,3),A(6),SA(6),SGN(3,3),GN(3,3),GI(3,3)
	DIMENSION SG(3,3),SI(3,3)
	COMMON/TRANF/ A,SA
	DATA RAD/57.2957795131/
	DO I=1,3
	DO J=1,3
	G(I,J)=0.0
	GI(I,J)=0.0
	SG(I,J)=0.0
	SI(I,J)=0.0
	GN(I,J)=0.0
	SGN(I,J)=0.0
	END DO
	END DO
	GOTO(401,402,403,404,405,406,407),ISYST
  401	DO I=1,3
	G(I,I)=A(1)*A(1)
	SG(I,I)=2.0*A(1)*SA(1)
	END DO
	GOTO 408
  402	DO I=1,2
	G(I,I)=A(1)*A(1)
	SG(I,I)=2.0*A(1)*SA(1)
	END DO
	G(3,3)=A(3)*A(3)
	SG(3,3)=2.0*A(3)*SA(3)
	GOTO 408
  403	DO I=1,3
	G(I,I)=A(I)*A(I)
	SG(I,I)=2.0*A(I)*SA(I)
	END DO
	GOTO 408
  404	DO I=1,2
	G(I,I)=A(1)*A(1)
	SG(I,I)=2.0*A(1)*SA(1)
	END DO
	G(3,3)=A(3)*A(3)
	SG(3,3)=2.0*A(3)*SA(3)
	G(1,2)=-0.5*G(1,1)
	G(2,1)=G(1,2)
	SG(1,2)=0.5*SG(1,1)
	SG(2,1)=SG(1,2)
	GOTO 408
  405   IF(IROMB.EQ.0) GOTO 404
        DO I=1,3
        G(I,I)=A(1)*A(1)
        SG(I,I)=2.0*A(1)*SA(1)
        END DO
        A4=A(4)/RAD
        CA4=DCOS(A4)
        SA4=DSIN(A4)
        G(1,2)=G(1,1)*CA4
        G(2,1)=G(1,2)
        G(1,3)=G(1,2)
        G(3,1)=G(1,3)
        G(2,3)=G(1,2)
        G(3,2)=G(2,3)
        SG(1,2)=DSQRT((2.0*A(1)*CA4*SA(1))**2+(A(1)*SA4*SA(4)/RAD)**2)
        SG(2,1)=SG(1,2)
        SG(1,3)=SG(1,2)
        SG(3,1)=SG(1,3)
        SG(2,3)=SG(1,2)
        SG(3,2)=SG(2,3)
        GOTO 408
  406	DO I=1,3
	G(I,I)=A(I)*A(I)
	SG(I,I)=2.0*A(I)*SA(I)
	END DO
	A5=A(5)/RAD
	CA5=DCOS(A5)
	SA5=DSIN(A5)
	G(1,3)=A(1)*A(3)*CA5
	G(3,1)=G(1,3)
	S1=(A(3)*CA5*SA(1))**2
	S2=(A(1)*CA5*SA(3))**2
	S3=(A(1)*A(3)*SA5*SA(5)/RAD)**2
	SG(1,3)=DSQRT(S1+S2+S3)
	SG(3,1)=SG(1,3)
	GOTO 408
  407	DO I=1,3
	G(I,I)=A(I)*A(I)
	SG(I,I)=2.0*A(I)*SA(I)
	END DO
	A6=A(6)/RAD
	CA6=DCOS(A6)
	SA6=DSIN(A6)
	G(1,2)=A(1)*A(2)*CA6
	G(2,1)=G(1,2)
	S1=(A(2)*CA6*SA(1))**2
	S2=(A(1)*CA6*SA(2))**2
	S3=(A(1)*A(2)*SA6*SA(6)/RAD)**2
	SG(1,2)=DSQRT(S1+S2+S3)
	SG(2,1)=SG(1,2)
	A5=A(5)/RAD
	CA5=DCOS(A5)
	SA5=DSIN(A5)
	G(1,3)=A(1)*A(3)*CA5
	G(3,1)=G(1,3)
	S1=(A(3)*CA5*SA(1))**2
	S2=(A(1)*CA5*SA(3))**2
	S3=(A(1)*A(3)*SA5*SA(5)/RAD)**2
	SG(1,3)=DSQRT(S1+S2+S3)
	SG(3,1)=SG(1,3)
	A4=A(4)/RAD
	CA4=DCOS(A4)
	SA4=DSIN(A4)
	G(2,3)=A(2)*A(3)*CA4
	G(3,2)=G(2,3)
	S1=(A(3)*CA4*SA(2))**2
	S2=(A(2)*CA4*SA(3))**2
	S3=(A(2)*A(3)*SA4*SA(4)/RAD)**2
	SG(2,3)=DSQRT(S1+S2+S3)
	SG(3,2)=SG(2,3)
  408	DO 3 I=1,3
	DO 2 J=1,3
	DO 1 K=1,3
	GI(I,J)=GI(I,J)+G(I,K)*TM(J,K)
	SI(I,J)=SI(I,J)+SG(I,K)*TM(J,K)
    1	CONTINUE
    2	CONTINUE
    3	CONTINUE
	DO 6 I=1,3
	DO 5 J=1,3
	DO 4 K=1,3
	GN(I,J)=GN(I,J)+TM(I,K)*GI(K,J)
	SGN(I,J)=SGN(I,J)+TM(I,K)*SI(K,J)
    4	CONTINUE
    5	CONTINUE
    6	CONTINUE
	DO I=1,3
	A(I)=DSQRT(GN(I,I))
	SA(I)=0.5*SGN(I,I)/A(I)
	END DO
	IF(DABS(GN(1,2)).LT.0.000001) THEN
	A(6)=90.0
	SA(6)=0.0
	ELSE
	SCO=GN(1,2)/A(1)/A(2)
	SSI=DSQRT(1.0-SCO*SCO)
	A(6)=RAD*DACOS(SCO)
	S1=(SGN(1,2)/GN(1,2))**2+(SA(1)/A(1))**2+(SA(2)/A(2))**2
	SA(6)=RAD*DABS(SCO/SSI)*DSQRT(S1)
	END IF
	IF(DABS(GN(1,3)).LT.0.000001) THEN
	A(5)=90.0
	SA(5)=0.0
	ELSE
	SCO=GN(1,3)/A(1)/A(3)
	SSI=DSQRT(1.0-SCO*SCO)
	A(5)=RAD*DACOS(SCO)
	S1=(SGN(1,3)/GN(1,3))**2+(SA(1)/A(1))**2+(SA(3)/A(3))**2
	SA(5)=RAD*DABS(SCO/SSI)*DSQRT(S1)
	END IF
	IF(DABS(GN(2,3)).LT.0.000001) THEN
	A(4)=90.0
	SA(4)=0.0
	ELSE
	SCO=GN(2,3)/A(2)/A(3)
	SSI=DSQRT(1.0-SCO*SCO)
	A(4)=RAD*DACOS(SCO)
	S1=(SGN(2,3)/GN(2,3))**2+(SA(3)/A(3))**2+(SA(2)/A(2))**2
	SA(4)=RAD*DABS(SCO/SSI)*DSQRT(S1)
	END IF
	RETURN
	END
C-------------------------------------------------------------------------
C-------------------------------------------------------------------------
C   
      SUBROUTINE DIBUJO
	PARAMETER (MX=500,NL=100)
        IMPLICIT REAL*8 (A-H,O-Z)
        CHARACTER TITLE*40,TIT*40
        CHARACTER ANS*1,LX*28,LY*20,LLX*28,LLY*20,AUX*9
        INTEGER ESC,GS,CAN
C
	DIMENSION ZERO(MX),U(MX),V(MX),W(MX),ALO(MX),A(MX),B(MX),C(MX)
	DIMENSION ALFA(MX),BETA(MX),GAMMA(MX),AN(6),SAN(6)
	DIMENSION SZERO(MX),SU(MX),SV(MX),SW(MX),SALO(MX),SA(MX),SB(MX)
	DIMENSION SC(MX),SALFA(MX),SBETA(MX),SGAMMA(MX),TM(3,3)
	DIMENSION T(MX),IHKL(NL,4),RPIK(MX),AREA(MX,NL),THETA(MX,NL)
	DIMENSION SAREA(MX,NL),VOL(MX),SVOL(MX),NUMOR(MX),RZER(MX)
        DIMENSION AX(MX),AY(NL,MX),SAY(NL,MX)
        DIMENSION LLY(18),LLX(4),AUX(NL),IDEN(NL)
C
        COMMON/TEMP/N,TITLE,NUMOR,T,RPIK,RZER
        COMMON/PROFALL/ZERO,SZERO,U,SU,V,SV,W,SW,ALO,SALO,A,SA,B,SB,C,SC
     &,ALFA,SALFA,BETA,SBETA,GAMMA,SGAMMA,VOL,SVOL
        COMMON/INTEN/NREF,IHKL,THETA,AREA,SAREA
        COMMON/LIMIN/Z1,U1,V1,W1,ALO1,A1,B1,C1,AL1,BE1,CE1,VOL1,T1,NUM1
        COMMON/LIMAX/Z2,U2,V2,W2,ALO2,A2,B2,C2,AL2,BE2,CE2,VOL2,T2,NUM2
        COMMON/IFIT/ICOD(15),IROMB,ISYST,RP1,RP2
        COMMON/CURV/NPO,X1,X2,Y1,Y2,AX,AY,SAY
        COMMON/TYPE/ICLASS,NCURV
        COMMON/LABEL/LX,LY,TIT
C
      DATA ESC,GS,CAN/27,29,24/
      DATA LLX/'       TEMPERATURE          ',
     &         '         NUMOR              ',
     &         '       2-THETA              ',
     &         '       FILE NUMBER          '/
      DATA LLY/'       ZERO         ',
     &         '        U           ',
     &         '        V           ',
     &         '        W           ',
     &         '       ALOR         ',
     &         '     G-FWHM         ',
     &         '     GL-FWHM        ',
     &         '        A           ',
     &         '        B           ',
     &         '        C           ',
     &         '       ALFA         ',
     &         '       BETA         ',
     &         '      GAMMA         ',
     &         '       VOL          ',
     &         '    INTENSITY       ',
     &         '     NUMOR          ',
     &         '   TEMPERATURE      ',
     &         '    R-FACTORS       '/
	DATA RAD/57.2957795131/
C
C
   50   FORMAT(A)     
        TIT=TITLE
        NPO=N
 1000	TYPE*,'    OPTIONS OF PLOT ' 
	TYPE*,'    **************  '
	TYPE*,'      '
	TYPE*,'  1- PLOT THE ZEROPOINT VERSUS T OR NUMOR'
        TYPE*,'  2- PLOT U,V,W OR ALOR        "          '
        TYPE*,'  3- PLOT FWHM AT SELECTED ANGLE'
	TYPE*,'  4- PLOT FWHM VERSUS 2THETA AT SELECTED T OR NUMOR'
	TYPE*,'  5- PLOT A,B,C,ALFA,BETA,GAMMA,VOL'
	TYPE*,'  6- PLOT PEAK POSITIONS'
	TYPE*,'  7- PLOT INTENSITY OF SELECTED PEAKS'
        TYPE*,'  8- PLOT R-FACTORS VERSUS NUMOR' 
        TYPE*,'  9- QUIT '
	TYPE*,'                     '
	READ(5,*,ERR=1000) IOP
        IF(IOP.LT.1.OR.IOP.GT.9) GOTO 1000
        GOTO(1,2,3,4,5,6,7,8,9),IOP
C--------------------------------
C  OPTION 1 (ZEROPOINT)
C--------------------------------
   1    IF(ICOD(5).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE ZEROPOINT PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF ZEROPOINT VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=Z1
         Y2=Z2
         ICLASS=1
         NCURV=1
         LY=LLY(1)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=ZERO(I)
              SAY(1,I)=SZERO(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=ZERO(I)
              SAY(1,I)=SZERO(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
C------------------------------------
C  OPTION 2 (PLOT OF U,V,W OR ALOR)
C------------------------------------
   2    TYPE*,'PLOT OF U,V,W OR ALOR (1/2/3/4)'
        READ(5,*,ERR=2) IPLOT
        GOTO(26,27,28,29),IPLOT
  26    IF(ICOD(6).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE U PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF U VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=U1
         Y2=U2
         ICLASS=2
         NCURV=1
         LY=LLY(2)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=U(I)
              SAY(1,I)=SU(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=U(I)
              SAY(1,I)=SU(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  27    IF(ICOD(7).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE V PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF V VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=V1
         Y2=V2
         ICLASS=3
         NCURV=1
         LY=LLY(3)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=V(I)
              SAY(1,I)=SV(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=V(I)
              SAY(1,I)=SV(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  28    IF(ICOD(8).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE W PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF W VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=W1
         Y2=W2
         ICLASS=4
         NCURV=1
         LY=LLY(4)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=W(I)
              SAY(1,I)=SW(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=W(I)
              SAY(1,I)=SW(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  29    IF(ICOD(9).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE ALOR PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF ALOR VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=ALO1
         Y2=ALO2
         ICLASS=5
         NCURV=1
         LY=LLY(5)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=ALO(I)
              SAY(1,I)=SALO(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=ALO(I)
              SAY(1,I)=SALO(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
C--------------------------------------
C  OPTION 3 (FWHM) = FWHM(T,NUMOR)
C--------------------------------------
   3    IF(ICOD(9).EQ.0.AND.ICOD(8).EQ.0.AND.ICOD(7).EQ.0.AND.
     &   ICOD(6).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE HAF-WIDTH PARAMETERS'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
 2025   TYPE*,' GIVE THE ANGLE 2-THETA TO CALCULATE HAF-WIDTH'
        READ(5,*,ERR=2025) THET
         Y1=1000.0
         Y2=-1000.0
         ICLASS=6
         NCURV=1
         LY=LLY(6)
        THET=DTAN(0.5*THET/RAD)
        TYPE*,' PLOT OF FWHM VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              HW=DSQRT((U(I)*THET+V(I))*THET+W(I))
              AY(1,I)=HW
           SS=0.5/HW*DSQRT((SU(I)*THET**2)**2+(SV(I)*THET)**2+SW(I)**2)
              SAY(1,I)=SS
              IF(HW+SS.GT.Y2) Y2=HW+SS
              IF(HW-SS.LT.Y1) Y1=HW-SS
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              HW=DSQRT((U(I)*THET+V(I))*THET+W(I))
              AY(1,I)=HW
           SS=0.5/HW*DSQRT((SU(I)*THET**2)**2+(SV(I)*THET)**2+SW(I)**2)
              SAY(1,I)=SS
              IF(HW+SS.GT.Y2) Y2=HW+SS
              IF(HW-SS.LT.Y1) Y1=HW-SS
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         IF(ICOD(9).EQ.0) GOTO 100
            DO I=1,N
              SS=THET*THET+1.0            
              HW=DSQRT(ALO(I)*SS)
              AY(2,I)=HW
              SS=0.5/HW*SS*SALO(I)
              SAY(2,I)=SS
              IF(HW+SS.GT.Y2) Y2=HW+SS
              IF(HW-SS.LT.Y1) Y1=HW-SS
            END DO
         ICLASS=7
         NCURV=2
         LY=LLY(7)
         GOTO 100
C--------------------------------------------------
C  OPTION 4 (FWHM) = FWHM(2THETA) AT SELECTED NUMOR 
C--------------------------------------------------
   4    IF(ICOD(9).EQ.0.AND.ICOD(8).EQ.0.AND.ICOD(7).EQ.0.AND.
     &   ICOD(6).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE HAF-WIDTH PARAMETERS'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
	X1=THETA(1,1)-2.0
	X2=THETA(1,NREF)+2.0
        LX=LLX(3)
        LY=LLY(6)
        ICLASS=6
        NCURV=1
        Y1=1000.0
        Y2=-1000.0
        STEPT=(X2-X1)/(N-1)
        TYPE*,' NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
        IF(ANS.EQ.'T') THEN
 2026     TYPE*,' THE TEMPERATURE RANGE IS: ',T1,T2
          TYPE*,' GIVE THE VALUE OF T: '
          READ(5,*,ERR=2026) TT
          J=(N-1)*(TT-T1)/(T2-T1)+1
          IF(T(1).GT.T(N)) J=N-J+1
        ELSE
 2027     TYPE*,' THE NUMOR RANGE IS: ',NUM1,NUM2
          TYPE*,' GIVE THE VALUE OF NUMOR: '
          READ(5,*,ERR=2027) NN
          J=(N-1)*DFLOAT((NN-NUM1))/DFLOAT(NUM2-NUM1)+1
          IF(NUMOR(1).GT.NUMOR(N)) J=N-J+1
        ENDIF
            DO I=1,N
              THET=X1+(I-1)*STEPT
              AX(I)=THET
              THET=DTAN(0.5*THET/RAD)
              HW=DSQRT((U(J)*THET+V(J))*THET+W(J))
              AY(1,I)=HW
          SS=0.5/HW*DSQRT((SU(J)*THET**2)**2+(SV(J)*THET)**2+SW(J)**2)
              SAY(1,I)=SS
              IF(HW+SS.GT.Y2) Y2=HW+SS
              IF(HW-SS.LT.Y1) Y1=HW-SS
            END DO
         IF(ICOD(9).EQ.0) GOTO 100
            DO I=1,N
              THET=DTAN(0.5*AX(I)/RAD)
              SS=THET*THET+1.0            
              HW=DSQRT(ALO(J)*SS)
              AY(2,I)=HW
              SS=0.5/HW*SS*SALO(J)
              SAY(2,I)=SS
              IF(HW+SS.GT.Y2) Y2=HW+SS
              IF(HW-SS.LT.Y1) Y1=HW-SS
            END DO
         LY=LLY(7)
         NCURV=2
         ICLASS=7
         GOTO 100
C--------------------------------------------
C  OPTION 5 (PLOT OF A,B,C,ALFA,BETA,GAMMA,VOL
C--------------------------------------------
   5    TYPE*,'PLOT OF A,B,C,ALFA,BETA,GAMMA,VOL (1/2/3/4/5/6/7)'
        READ(5,*,ERR=5) IPLOT
        GOTO(30,31,32,33,34,35,36),IPLOT
  30    IF(ICOD(10).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE A PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF A VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=A1
         Y2=A2
         ICLASS=8
         NCURV=1
         LY=LLY(8)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=A(I)
              SAY(1,I)=SA(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=A(I)
              SAY(1,I)=SA(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  31    IF(ICOD(11).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE B PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF B VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=B1
         Y2=B2
         ICLASS=9
         NCURV=1
         LY=LLY(9)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=B(I)
              SAY(1,I)=SB(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=B(I)
              SAY(1,I)=SB(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  32    IF(ICOD(12).EQ.0) THEN
        IF(ISYST.EQ.5.AND.IROMB.EQ.0) GOTO 321
        TYPE*,' YOU HAVE NOT FITTED THE C PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
 321    TYPE*,' PLOT OF C VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=C1
         Y2=C2
         ICLASS=10
         NCURV=1
         LY=LLY(10)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=C(I)
              SAY(1,I)=SC(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=C(I)
              SAY(1,I)=SC(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  33    IF(ICOD(13).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE ALFA PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF ALFA VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=AL1
         Y2=AL2
         ICLASS=11
         NCURV=1
         LY=LLY(11)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=ALFA(I)
              SAY(1,I)=SALFA(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=ALFA(I)
              SAY(1,I)=SALFA(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  34    IF(ICOD(14).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE BETA PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF BETA VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=BE1
         Y2=BE2
         ICLASS=12
         NCURV=1
         LY=LLY(12)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=BETA(I)
              SAY(1,I)=SBETA(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=BETA(I)
              SAY(1,I)=SBETA(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  35    IF(ICOD(15).EQ.0) THEN
        TYPE*,' YOU HAVE NOT FITTED THE GAMMA PARAMETER'
        TYPE*,' PRESS <CR> KEY TO CONTINUE'
        ACCEPT 50,ANS
        GOTO 1000
        ENDIF
        TYPE*,' PLOT OF GAMMA VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=CE1
         Y2=CE2
         ICLASS=13
         NCURV=1
         LY=LLY(13)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=GAMMA(I)
              SAY(1,I)=SGAMMA(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=GAMMA(I)
              SAY(1,I)=SGAMMA(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
  36    TYPE*,' PLOT OF CELL-VOLUME VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=VOL1
         Y2=VOL2
         ICLASS=14
         NCURV=1
         LY=LLY(14)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              AY(1,I)=VOL(I)
              SAY(1,I)=SVOL(I)
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              AY(1,I)=VOL(I)
              SAY(1,I)=SVOL(I)
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
C------------------------------------
C  OPTION 6 PLOT OF PEAK POSITIONS
C------------------------------------
   6    TYPE*,' PEAK POSITIONS VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         X1=THETA(N,1)-2.0
         X2=THETA(1,NREF)+2.0
         LX=LLX(3)
         ICLASS=16
         NCURV=NREF
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              DO J=1,NREF
              AY(J,I)=THETA(I,J)
              END DO
            END DO
         Y1=T1
         Y2=T2
         LY=LLY(17)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              DO J=1,NREF
              AY(J,I)=THETA(I,J)
              END DO
            END DO
         Y1=DFLOAT(NUM1)
         Y2=DFLOAT(NUM2)
         LY=LLX(16)
         ENDIF
         GOTO 100
C-----------------------------------------------
C  OPTION 7 PLOT OF INTENSITIES OF SELECTED PEAK
C-----------------------------------------------
   7    TYPE*,'NUMBER OF PEAK-INTENSITIES TO BE PLOTED'
        READ(5,*,ERR=7) NCURV
2028    TYPE*,' AVAILABLE PEAKS ARE:'
        TYPE*,'     '
        TYPE*,'IDEN -   H  K  L   IC * IDEN  -   H  K  L   IC ' 
        DO J=1,NREF,2
        WRITE(6,300) J,(IHKL(J,K),K=1,4),J+1,(IHKL(J+1,L),L=1,4)
        END DO
 300    FORMAT(I5,' - ',3I3,I5,' * ',I5,' - ',3I3,I5)
        TYPE *,'   '
        TYPE*,' ENTER',NCURV,' IDEN PEAKS FOR PLOT'
        READ(5,*,ERR=2028) (IDEN(J),J=1,NCURV)
        TYPE*,' PEAK-INTENSITIES VERSUS NUMOR OR TEMPERATURE (N/T)'
        ACCEPT 50,ANS
         Y1=99999999.0
         Y2=-9999999.0
         ICLASS=15
         LY=LLY(15)
        IF(ANS.EQ.'T') THEN
            DO I=1,N
              AX(I)=T(I)
              DO J=1,NCURV
              K=IDEN(J)
              S1=AREA(I,K)
              SS=SAREA(I,K)
              AY(J,I)=S1
              SAY(J,I)=SS
              IF(S1+SS.GT.Y2) Y2=S1+SS
              IF(S1-SS.LT.Y1) Y1=S1-SS
              END DO
            END DO
         X1=T1
         X2=T2
         LX=LLX(1)
         ELSE
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I))
              DO J=1,NCURV
              K=IDEN(J)
              S1=AREA(I,K)
              SS=SAREA(I,K)
              AY(J,I)=S1
              SAY(J,I)=SS
              IF(S1+SS.GT.Y2) Y2=S1+SS
              IF(S1-SS.LT.Y1) Y1=S1-SS
              END DO
            END DO
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         LX=LLX(2)
         ENDIF
         GOTO 100
C-----------------------------------------
C  OPTION 8 PLOT OF R-FACTORS VERSUS NUMOR
C-----------------------------------------
   8     TYPE*,' R-FACTORS VERSUS NUMOR OR FILE-NUMBER (N/F)'
         ACCEPT 50,ANS
         IROP=0
         LX=LLX(2)
         X1=DFLOAT(NUM1)
         X2=DFLOAT(NUM2)
         IF(ANS.EQ.'F') THEN
           IROP=1
           LX=LLX(4)
           X1=1.0
           X2=DFLOAT(N)
         ENDIF
         Y1=RP1
         Y2=RP2
         S1=(RP2-RP1)/50.0
         S2=0.5*S1
         ICLASS=18
         NCURV=2
         LY=LLY(18)
            DO I=1,N
              AX(I)=DFLOAT(NUMOR(I)*(1-IROP)+IROP*I)
              AY(1,I)=RZER(I)
              AY(2,I)=RPIK(I)
              SAY(1,I)=S1
              SAY(2,I)=S2
            END DO
	TYPE *,'  LIMITS OF PLOT XMIN-XMAX , YMIN-YMAX'
	TYPE 1111,X1,X2,Y1,Y2
1111	FORMAT(4F12.5)
9090	CONTINUE
 100    TYPE*,'PLOTTING DEVICE (Tektro/Laser/Benson)'
        ACCEPT 50,ANS
        IDEVICE=0
        IF(ANS.EQ.'T') IDEVICE=1
        IF(ANS.EQ.'L') IDEVICE=2
        IF(ANS.EQ.'B') IDEVICE=3
        IF(IDEVICE.EQ.0) THEN
           TYPE 50,' DEVICE ',ANS, 'NON-EXISTENT'
           GOTO 9090
        ENDIF
C        IF(IDEVICE.EQ.1) WRITE(6,101) CHAR(ESC),CHAR(GS)
        CALL PLOT_2D(IDEVICE)
        IF(IDEVICE.EQ.2.OR.IDEVICE.EQ.3) GOTO 1000
	DO 9050 JJJ=1,NCURV
        TYPE*,'STORE DATA OF THIS (THESE) PLOT(S) (N/Y)'
        ACCEPT 50,ANS
        IF(ANS.EQ.'N') THEN
C           WRITE(6,101) CHAR(ESC),CHAR(CAN)
           GOTO 1000
        ENDIF
C        WRITE(6,101) CHAR(ESC),CHAR(CAN)
C        IF(ANS.EQ.'L') IDEVICE=2
C        IF(ANS.EQ.'B') IDEVICE=3
C        CALL PLOT_2D(IDEVICE)
	TYPE *,'NAME OF THE OUTPUT FILE'
	ACCEPT 200,FILEN2
	OPEN(UNIT=24,NAME=FILEN2,TYPE='NEW',FORM='FORMATTED')
200	FORMAT(A16)
	WRITE(24,*)N
	DO 201 I=1,N
	WRITE(24,*)AX(I),AY(JJJ,I),SAY(JJJ,I)
201	CONTINUE
9050	CLOSE(UNIT=24)
        GOTO 1000
   9    RETURN
  101   FORMAT(2A)
	END
C******************************************************************************
C
C     *******************************************
C
      SUBROUTINE PLOT_2D(DEVICE)
C
C     *******************************************
C
C  LINK PLOT_2D,ILLLIB:GRLIB/L,NAG/L,GKSINT/L,GKSBX/L,BENLIB/L
C
C******************************************************************************
	PARAMETER (MX=500,NL=100)
C
        DOUBLE PRECISION AY(NL,MX),SAY(NL,MX)
        INTEGER DEVICE
	DOUBLE PRECISION XMIN,XMAX,YMIN,YMAX 
	DOUBLE PRECISION UMIN,UMAX,VMIN,VMAX
	DOUBLE PRECISION AX(MX)
	DOUBLE PRECISION BX(2),BY(2)
        COMMON/CURV/N,XMIN,XMAX,YMIN,YMAX,AX,AY,SAY
        COMMON/TYPE/ICLASS,NCURV
        COMMON/LABEL/LABELONX,LABELONY,TITLE
	VIRTUAL YOO(1050),X(1050)
	 COMMON/TRAN/M0
C
C
C
C
C	PROGRAMME DE TRACE ECRAN DES .LT4 OU AUTRES
C
C
	X1=XMIN
	X2=XMAX
	X3=YMIN
	X4=YMAX
	M0=N
	TYPE *,M0
	DO 2 JJJ=1,NCURV
	DO 1 I=1,M0
	YOO(I)=AY(JJJ,I)
1	X(I)=AX(I)
	CALL TRACE(YOO,X,X1,X2,X3,X4,JJJ)
2	CONTINUE
	CALL GREND
	RETURN
	END
	SUBROUTINE TRACE(YOO,X,XMIN,XMAX,YMIN,YMAX,JJJ)
	VIRTUAL YOO(1050),X(1050)
	COMMON/TRAN/M0
	IF(JJJ.GT.1)GO TO 2
	CALL INIT
2	CALL POINTA(0.,760.)
	CALL TSEND
	CALL IOWAIT(20)
	CALL HOME
	CALL GRA(XMIN,XMAX,YMIN,YMAX,X,YOO,2)
	YY=-YMIN/(YMAX-YMIN)*720.
	CALL VIDBUF
	TYPE 1
1	FORMAT('  FAIRE 1 POUR CONTINUER',$)
	ACCEPT *,KR
C	CALL GREND	
	RETURN
	END
	SUBROUTINE GRID(DX,DY)
	CALL POINTA(DX,DY)
	CALL DRAWA(1023.,DY)
	RETURN
	END
	SUBROUTINE GRA(X1,X2,Y1,Y2,E,Y,N)
	VIRTUAL E(1050),Y(1050)
	COMMON/TRAN/M0
	DO 1 I=1,M0
	YIY=((Y(I)-Y1)/(Y2-Y1))*720.
	XIX=((E(I)-X1)/(X2-X1))*1023.
	GO TO (604,605),N
604	CALL POINTA(XIX,YIY)
	GO TO 1
605	IF(I.EQ.1)CALL POINTA(XIX,YIY)
	CALL DRAWA(XIX,YIY)
1	CONTINUE
	CALL VIDBUF
	RETURN
	END

C2000    DO I=1,N
C        Y(I)=AX(I)
C        END DO
C        DO J=1,NCURV
C            DO I=1,N
C             X(I)=AY(J,I)
C            END DOC
C	CALL	J06BAF(X,Y,N,ITYPE,KSYM,IFAIL)
C        END DO
